/* ======================================================================
       Program description.....returns header information about .PCX files
       Author..................D.Gannon, Leeds, UK
       Date....................17th June 1994
       Written.................Turbo C/C++ 3.00
   =====================================================================*/

#include <stdio.h>
#include <conio.h>

main( int argc, char *argv[] )
{

  FILE *filename;

     // header structure for a .PCX file
    struct header
	   {
	    unsigned char manufacturer ;
	    unsigned char version ;
	    unsigned char encode;
	    unsigned char bits;
		      int xmin;
		      int ymin;
		      int xmax;
		      int ymax;
		      int xres;
		      int yres;
	    unsigned char colormap[48];
	    unsigned char reserved;
	    unsigned char number_of_planes;
	     unsigned int bytes_per_line;
		      int palette_info;
	    unsigned char filler[58];
	   } pcx_header;


   int xheight = 0,
       yheight = 0;
   int       i = 0;

  if(argc != 2)
   {
     printf("\r\nUSAGE - GETPCX <filename>\r\n");
     return(1);
    }

  // see if the file exists
  if ( (filename = fopen( argv[1], "rb") ) == NULL)
   {
     printf("ERROR! Cannot open file.\n");
     return (2);
    }

    //read the header info. into the structure buffer
    fread(&pcx_header,sizeof(pcx_header),1,filename);

    xheight = ( pcx_header.xmax - pcx_header.xmin ) + 1;
    yheight = ( pcx_header.ymax - pcx_header.ymin ) + 1;

  fclose(filename);

    printf("PCX Header information for %s  (C) 1994 D.Gannon\r\n\r\n", argv[1] );

    if(pcx_header.manufacturer == 0x0a)
     printf("Zsoft .PCX format\r\n");

     printf("Version ");

    switch(pcx_header.version)
     {
      case 0x00:printf("2.5\r\n");
		break;
      case 0x02:printf("2.8 with palette info\r\n");
		break;
      case 0x03:printf("2.8 with no palette info\r\n");
		break;
      case 0x05:printf("3.0\r\n");
		break;
	default:printf("unknown\r\n");
      }

    if(pcx_header.encode == 0x01)
     printf("Run length encoded\r\n");
    else
     printf("Not encoded\r\n");

    printf("%d bit(s) per pixel\r\n", pcx_header.bits );
    printf("Origin at %d,%d ..pixels\r\n", pcx_header.xmin, pcx_header.ymin );
    printf("End at %d,%d ..pixels\r\n", pcx_header.xmax, pcx_header.ymax );
    printf("Image is %d pixels wide by %d pixels high\r\n", xheight, yheight );
    printf("Created on a %d X %d device\r\n", pcx_header.xres, pcx_header.yres );
    printf("Number of planes is %d   ( 4 = EGA, 1 = VGA )\r\n", pcx_header.number_of_planes );
    printf("%d byte(s) per line\r\n\r\n",pcx_header.bytes_per_line );

    for (i = 0; i<= 47; i++)
     {
      printf("%d ",pcx_header.colormap[i] );
     }


 return 0;
}